---
dg-publish: true
dg-home-link: false
tags: [ics3u]
---
# Thread 1 Portfolio Review
## How does this work?
Cast an appraising eye at your portfolio.  Decide whether you are, currently:

- Approaching expectations
	- Up to 70%
- Meeting expectations
	- 70% to 85%
- Exceeeding expectations
	- Greater than 85%

For this portfolio review, please estimate your percentage grade to within a few points.

> [!TODO]
> Before you meet with Mr. Gordon, make a brief post [on Spaces](https://ca.spacesedu.com/). Did you [[#How to roughly evaluate your learning skills|demonstrate strong learning skills]]? [[#How to estimate your current grade|Estimate your grade range]] and identify why you feel you have earned it. Then go on to briefly identify what you feel you could improve upon. Finally, what specific next steps might you take to continue learning?

The overall purpose of your portfolio is to provide evidence of mastery of the [course learning goals](https://www.russellgordon.ca/cs/learning-goals/learning-goals-for-grade-11/).

## How to roughly evaluate your learning skills

To show that you have excellent learning skills, be sure you have:
- [ ] completed assigned exercises from:
	- [[Section 1/Thread 1/Day 5|Day 5]]: write structure(s) to represent hockey cards
	- Days [[Section 1/Thread 1/Day 7|7]], [[Section 1/Thread 1/Day 8|8]], [[Section 1/Thread 1/Day 9|9]], and [[Section 1/Thread 1/Day 12|12]]: Essentially, get your Favourite Things app [[Favourite Things|to the point where it looks like this]] but additionally has a [[Photo Caption and Credit|photo caption and credit]] and an [[Enhanced List View for FavouriteThings|enhanced list view]]
	- [[Section 1/Thread 1/Day 11|Day 11]]: experimented with SwiftUI layouts
	- Day [[Section 1/Thread 1/Day 13|13]]: Reproduced the Stopwatch App interface

## How to estimate your current grade

To *meet* expectations, be sure you have:
- [ ] met the success criteria for the [[Section 1/Tasks/Name Plate|Name Plate]] task and made at least *some* of the improvements that you were given time to complete from days [[Section 1/Thread 1/Day 2|2]], [[Section 1/Thread 1/Day 3|3]],  [[Section 1/Thread 1/Day 4|4]], and [[Section 1/Thread 1/Day 6|6]]
- [ ] met the success criteria for the [[Section 1/Tasks/Geometric Figures|Geometric Figures]] task
- [ ] met the success criteria for the [[Reproduce an Interface|end-of-thread task where you are reproducing an iOS interface]]

> [!IMPORTANT]
> Whatever you have done must be clearly documented in your portfolio, with supporting screenshots *and* text summarizing what you are showing and what you have learned.

## Approaching Expectations

If you are missing evidence in your portfolio for the tasks noted above, you are *approaching* expectations.

## Exceeding Expectations

If you have evidence in your portfolio that suggests further mastery of a [[Current Courses/Grade 10 Introduction to Computer Studies/Learning Goals|course learning goal]], but which was not explicitly spelled out in the success criteria for a task, you may be *exceeding* expectations. For example:

- You might have made *every* suggested improvement to your Name Plate drawing, or made multiple name plates that show a strong understanding of concepts like loops, functions, and random numbers.
- You might have experimented with creating user interfaces with SwiftUI in another project.
- You might have re-created an exceptionally complex user interface for your end-of-thread task, or added additional functionality, or reproduced multiple user interfaces.

How a given student exceeds expectations will vary and is not limited to the examples provided above.