---
dg-publish: true
dg-home-link: false
tags: [ics3u]
---
# Geometric Figures
## Objective
Write a structure that models a geometric figure.
## What you'll need to begin
- [ ] Xcode
- [ ] The [EQAO Grade 9 Academic Math formula sheet](https://www.icloud.com/iclouddrive/06dGpE079oKxgeS8JF59TVkNw#Grade_9_EQAO_Formula_Sheet_-_Section_2_-_Assigned_Figures)
> [!NOTE]
> The green labels on the formula sheet indicate the assigned shape or figure for each student in our class.
- [ ] A new project to work within, that in turn contains a playground, with a remote
> [!TIP]
> Here is [how to create that new project, playground page, and remote](https://www.youtube.com/embed/Q_Scyx2I5z0).
## Success criteria
- [ ] structure has:
	- [ ] an appropriate name with correct capitalization
	- [ ] necessary *stored properties* with appropriate names and data types
	- [ ] necessary *computed properties* to provide:
		- [ ] perimeter and area (for 2D shapes)
		- [ ] surface area and volume (for 3D shapes)
		    > [!NOTE]
		    > ∙ You may assume that the dimensions of the figure do *not* need to change.
		    > ∙ Make an appropriate decision about how to define your structure's properties.
- [ ] playground has:
	- [ ] the structure definition, as described above
	- [ ] at least two *instances* of the structure, showing that stored and computed properties work correctly
- [ ] you have used source control well by [committing and pushing your work](https://www.russellgordon.ca/cs/source-control/introduction/using-source-control.pdf) at regular intervals
## Exemplar
This is a partially completed task – the implementation details for the rectangle are deliberately hidden:

![[Screen Shot 2022-11-04 at 6.55.37 AM.png]]

> [!TIP]
> If you need the value of $\pi$ in your formula, you can obtain it using this code: `Double.pi`
## References
Optionally, refer back to these lessons while completing this task:
- [Data Types and Structures](https://www.icloud.com/iclouddrive/02bZ1_CZz0Vlh5iIdP7MzgtxA#Data_Types_and_Structures)
- [Structures: Going Beyond Stored Properties](https://www.icloud.com/iclouddrive/0c3cvuJ4uNIKATeNReCasjeyw#2b_-_Structures_-_Going_beyond_stored_properties)
## Learning goals
Successful completion of this task is great initial evidence for [learning goals 1, 2, and 3](https://www.russellgordon.ca/cs/learning-goals/learning-goals-for-grade-11/).