---
dg-publish: true
dg-home-link: false
---
### Thread 1, Day 11 - Saturday, November 5, 2022
#### Agenda
1. Reference Book: SwiftUI Views Quick Start
	- Many programmers refer to *reference books* as they learn
	- Mark Moeykens is a talented author of technical reference books, who runs [Big Mountain Studio](https://www.bigmountainstudio.com)
	- He wrote an outstanding book named **SwiftUI Views Quick Start**, and generously provides it free of charge
		- ==To simplify matters while I am away from class today, you can [directly access a copy of SwiftUI Views Quick Start here](https://drive.google.com/file/d/19q9TiI0C3TJW7SGUavhA0sezGZceDNBH/view?usp=share_link)==
			- To access the file, you need to be logged in to your LCS Google account
			- You may wish to download that PDF file directly to your computer for use in the future
				- To download the PDF file, look for this icon in the top-right corner of your browser  window: 
				![[Screen Shot 2022-11-05 at 6.25.51 AM.png|600]]
		- Other books Mark authored are also excellent, but are not provided free of charge
			- These books cover more advanced topics that you may choose to use later this year or in the grade 12 computer science course
2. SwiftUI: Basic Concepts and Terms
	- From the [SwiftUI Views Quick Start](https://drive.google.com/file/d/19q9TiI0C3TJW7SGUavhA0sezGZceDNBH/view?usp=share_link) book, please read through the *Basic Concepts* section from pages 12 to 20 in the PDF file
		- This will only take you a few minutes
1. SwiftUI: Understanding Mark's `HeaderView`
	- When you see code it's important that how it works is not a mystery to you
		- Mark includes the same standard layout at the start of all his code examples and screenshots
		- This layout is created from a SwiftUI view named `HeaderView`
		- To understand how `HeaderView` works, please review the *My Template* section from [pages 31 to 39 of the Swift UI Views Quick Start](https://drive.google.com/file/d/19q9TiI0C3TJW7SGUavhA0sezGZceDNBH/view?usp=share_link)
		- This is a good initial example of how to do basic formatting in SwiftUI
		- ==It is often easier to learn by trying things out as you go.==
			- So, you are asked to:
				- [create a new project in Xcode, of type iOS App, named **HeaderExample**](https://www.youtube.com/embed/z5pwFrmgcNk)
				- then, as you read pages 31 to 39, try typing in the code Mark provides within the `body` property in his examples
2. Exercise: Experiment with SwiftUI Layouts
	- **Option 1:** Extend Name Badge
		- Go back to the Name Badge project we started in a prior class.
		- Make the view's visual appearance look like this:
		  ![[Screen Shot 2022-11-05 at 7.08.34 AM.png|300]]
		- If you wish, use the complete [SwiftUI Views Quick Start book](https://drive.google.com/file/d/19q9TiI0C3TJW7SGUavhA0sezGZceDNBH/view?usp=share_link) as a reference, or, refer to [this PDF that contains a subset of concepts](https://drive.google.com/file/d/1KowxWGeBQGdbW6PtuvRxWZ3ayjp8jzXL/view?usp=share_link) that you will probably find most useful right now
		- You will find this [visual reference to fonts available within an iOS app](http://iosfonts.com) to be useful
			- For example, to get my name to appear with the font shown above, I used this code:
			  ![[Screen Shot 2022-11-05 at 7.33.04 AM.png|500]]
		  - Here is [another good reference for different font weights and variations](https://daddycoding.com/2019/12/26/swiftui-text/) that are available.
			  
	- **Option 2:** Freestyle
		- Create a new SwiftUI view and experiment with formatting by referring to SwiftUI Views Quick Start.
#### To-do items
*Before our next class...*
- [ ] Complete the tasks from today's agenda
- [ ] Be sure to share your results, and questions, [on Spaces](https://ca.spacesedu.com/) when you are done