---
dg-publish: true
dg-home-link: false
---
# App Ideas

The best app idea is one you are excited about. If you're having trouble finding an idea, browse the list below.

## Weather Wizard

Given the weather forecast and the outdoor activity you'd be doing that day, the app makes recommendations for what to wear.

- User could provide the anticipated weather, or, the app might look this up for them based on current location.
- Clothing items would be tagged with weather conditions and temperature ranges they are appropriate for and this data (stored in a database) would be used to generate recommendations.

**Technical challege level:** moderate.

## Meme Maker

Select a photo from your device's photo library and then overlay text to create a meme.

- Tutorials exist to learn how to import a photo from the photo library.
- Mr. Gordon has an example from Musicals @ LCS that makes it straightforward to export a SwiftUI view (the completed meme) to an image.
- Ideally, user could save memes for future reference, which involves use of a database.

**Technical challege level:** high.

## Random Groups Generator

Given a list of names, randomly generate groups using some nice animations.

- Selected groups could be saved for future reference, along with a note regarding how well the randomly selected group worked together; this would involve use of a database.

**Technical challenge level:** moderate.

## Review App

User can add terms, definitions, and possibly photos themselves to the app, then select a subset to include within a quiz. App might track which terms and definitions are being answer correctly and provide charts to illustrate this.

**Technical challenge level:** moderate to high, based on how far you take the idea.

## Score Tracker

Allows the user to track scores of their teams across various leagues, all in one convenient app.

**Technical challenge level:** moderate, based on having to parse JSON in different formats from multiple websites.

## Dining Hall Menu

The week's meals for LCS delivered to you daily, directly on your phone.

- Involves the use of the Sheety website as a data source.
- Could make use of on-device notifications.

> [!NOTE]
> Mr. Gordon has authored existing tutorials and example code for using Sheety and scheduling notifications.

**Technical challenge level:** high, based on having to work with something new (the Sheety service and notifications).

## Scoring Apps

Write a score or action tracking app for the sport of your choice. Needs will vary by sport – for example, scoring a tennis match is a very different set of requirements as compared to scoring individual plays for a baseball game. Allow a history of scored games to be reviewed.

**Technical challenge level:** moderate.

## Dog Breed Recommendations

The user lists things that are important to them, and the app makes dog breed recommendations.

- This is somewhat similar as a concept to the [[#Weather Wizard]] app.
- Might incorporate photos from the [dog.ceo](https://dog.ceo/dog-api/) API.

**Technical challenge level:** moderate.

## Complementary Colour Generator

The app allows the user to select colours, and it shows complementary colour combinations. The user can save colour swatches for future reference.

- Once you understand how the [hue-saturation-brightness colour model works](https://www.russellgordon.ca/lcs/HSB_Color_Model_Summary_Swift.pdf), this is not so hard.

**Technical challenge level:** moderate.

## Learn Names

Select photos from your device's photo library and assign names to them. App then quizzes you in various ways based on the set of names you have defined. The goal is to become proficient at recognizing who is whom.

- Tutorials exist to learn how to import a photo from the photo library.

**Technical challenge level:** moderate to high, based on how far you take the idea.


> [!NOTE]
> Mr. Gordon has a few other ideas that are better described verbally, so be sure to ask if you're super stuck.