---
dg-publish: true
dg-home-link: false
tags: [ics3u]
---
# Model Data in an App
## Objective
Write an app that models and manages data: either with a database, or from a [remote online data source](https://teaching.russellgordon.ca/json/useful-json-endpoints/), or with both.
## What you'll need to begin
- [ ] Xcode
- [ ] Your notes from having completed the tutorials and exercises from module 3 of this course
- [ ] If you choose to use data from an online data source, these lists of possible data sources will be useful:
	- [Mr. Gordon's curated list](https://teaching.russellgordon.ca/json/useful-json-endpoints/)
	- A larger list of [possible data sources](https://github.com/toddmotto/public-apis)
		- Some would be great options
		- Some are not so useful
		- Some require payment to access – don't use these.
- [ ] You may find [[Modelling Data Returned From an Endpoint|these additional examples of how to model data]] from an online data source helpful.

## Success criteria

1. Correct use of source control – regular commits and pushes to a remote, with meaningful messages.
2. A functional and reasonably appealing user interface.
3. Your app must take input, produce output, and make use of a list (array).
4. Your app must model data, working with a database, [an online data source](https://teaching.russellgordon.ca/json/useful-json-endpoints/), or both.
5. Include a written summary explaining clearly why you made the choices you did regarding the data model used.

## Exemplars

Any of the exercises given in this module would *meet* expectations for this task.

Combining use of a database with use of a remote online data source would exceed expectations for this task.

## Progress updates

Prior to the deadline, [on Spaces](https://ca.spacesedu.com/) :
- [ ] Share progress regularly in your private portfolio space
	- [ ] Be sure to post screenshots
	- [ ] ==Be sure to post the address of your GitHub remote at some point==

## Due date

The soft deadline for this task is by the ==*end of our class*== on Thursday, April 20, 2023. Aim for this.

However, you may ==optionally== complete work up to 11 PM on Saturday, April 22, 2023. This is a hard deadline.

**No source code commits will be reviewed that are made after the hard deadline.**

**No posts on Spaces will be reviewed if posted after the hard deadline.**

## Learning goals
Successful completion of this task is great evidence for these learning goals:
- [[Learning Goals#1|1]]
- [[Learning Goals#2|2]]
- [[Learning Goals#3|3]]
- [[Learning Goals#4|4]]
- [[Learning Goals#5|5]]
- [[Learning Goals#7|7]]
- [[Learning Goals#10|10]]
