---
dg-publish: true
dg-home-link: false
tags: [ics3u]
---
# Reproduce an Interface
## Objective
Reproduce the user interface for part of an app.
## What you'll need to begin
- [ ] Xcode
- [ ] a copy of the [ Views and Controls App](https://github.com/lcs-rgordon/ViewsAndControls) that has been [[Cloning Views and Controls Project|cloned to your computer]] for [[Using Views and Controls Project|reference]] while you work on this task
- [ ] the [SF Symbols App](https://developer.apple.com/sf-symbols/) installed on your computer, also for reference
- [ ] a copy of [SwiftUI Views Quick Start](https://drive.google.com/file/d/19q9TiI0C3TJW7SGUavhA0sezGZceDNBH/view?usp=share_link) downloaded to your computer, so you can look up examples as needed
## Success criteria
- [ ] made a rough plan where you have identified how various structures might be used: `VStack`, `HStack`, `ZStack`, `Image`, et cetera
- [ ] for the most part, accurately reproduced your chosen app's user interface
- [ ] made use of [[Composition of Views Using Custom Structures|custom structures]] to reduce the use of repetitive code – in other words, you've applied *abstraction*
- [ ] written code that is well-formatted and easy to read
- [ ] you have used source control well by [committing and pushing your work](https://www.russellgordon.ca/cs/source-control/introduction/using-source-control.pdf) to a remote on GitHub at regular intervals
## Exemplar
Given an interface you wish to reproduce:

![[Screen Shot 2022-11-15 at 1.06.01 PM.png|300]]

Here is what a rough plan to reproduce part of an interface might look like:

![[IMG_1565.jpg|400]]

The rest of the task is to reproduce an app's interface, like you did [[Reproducing the Digital Stopwatch Interface, Part 1|with the Stopwatch tab in the Clock app]].

## Progress and due date
The task is due by the *end of our class* this Friday, November 18, 2022.

This is a firm deadline as we are at the end of the current module.

Prior to the final deadline, [on Spaces](https://ca.spacesedu.com/) :
- [ ] Share progress regularly in your private portfolio space
	- [ ] Be sure to post screenshots
	- [ ] Be sure to post the address of your GitHub remote at some point

> [!NOTE]
> Your work is not considered as handed in until the GitHub remote has been shared *and* you have [committed and pushed](https://www.russellgordon.ca/cs/source-control/introduction/using-source-control.pdf) all your work.

## Selecting an interface to reproduce
Each student must select a different app's interface to reproduce.

You can select an interface from the examples provided below, or propose your own, by making a post to our shared class space [on Spaces](https://ca.spacesedu.com/).

Indicate that you are choosing to do an interface by uploading a copy of the image to your post on Spaces.

![[IMG_1605.png|200]]
![[IMG_1604.png|200]]
![[IMG_1603.png|200]]
![[IMG_1602.png|200]]
![[IMG_1601.png|200]]
![[IMG_1600.png|200]]
![[IMG_1599.png|200]]
![[IMG_1598.png|200]]
![[IMG_1597.png|200]]
![[IMG_1596.png|200]]
![[IMG_1595.png|200]]
![[IMG_1594.png|200]]
![[IMG_1593.png|200]]
![[IMG_1592.png|200]]
![[IMG_1591.png|200]]
![[IMG_1590.png|200]]
![[IMG_1589.png|200]]
![[IMG_1588.png|200]]
![[IMG_1586.png|200]]

## Learning goals
Successful completion of this task is great initial evidence for [learning goals 1, 2, 3, and 5](https://www.russellgordon.ca/cs/learning-goals/learning-goals-for-grade-11/).
